<?php
/*
Plugin Name: Got Banners
Plugin URI: http://gotchance.com/got-banners-plugin/
Description: Got Banners is a simple plugin for rotating banners (especially 125 x 125px) like on TechCrunch.com & GotChance.com. Unlike other banner rotators, Got Banners rotate all of the banners putting them in a random order each time.
Version: 1.0
Author: Shrihari Sankaran
Author URI: http://gotchance.com/
*/

add_action('admin_menu', 'gb_add_pages');

function widget_gotbanners_init() {



function gb_add_pages() 
{
	add_options_page('Got Banners Options', 'Got Banners', 10, 'gotbanners', 'got_page');
}

function got_rand($min, $max, $num) 
{
    	if ($min<$max && $max-$min+1 >= $num && $num>0) 
	{
        	$random_nums = array();
        	$i=0;
        	while($i<$num) 
		{
            	$rand_num = rand($min, $max);
            	if (!in_array($rand_num, $random_nums)) 	
			{
                		$random_nums[] = $rand_num;
                		$i++;
           	 	}
        	}
  		return $random_nums;
    	} 
	else 
	{
        	return false;
    	}
}


function got_page()
{
echo '<div class="wrap">
	<h2>Got Banners Options</h2>
	<fieldset class="options">
	<legend>Enter your banner codes separated by a Tilde (~)</legend>';

if (isset($_POST['ads'])) 
{
	$handle = fopen("../wp-content/plugins/gotbanners/gotbanners.txt", "w");

 	$gads = stripslashes($_POST['ads']);

 	fwrite($handle, $gads);
 	fclose($handle);
}

 	$gads = file_get_contents("../wp-content/plugins/gotbanners/gotbanners.txt");

echo '<form action="'.$_SERVER['PHP_SELF'].'?page=gotbanners" method="post">
 	<textarea name="ads" rows="30" cols="100">'.$gads.'</textarea>
 	<input name="gsubmit" type="submit" value="Save">';

echo '</fieldset></div>';

}

function got_banners()
{
	$fcontents = join ('', file ('wp-content/plugins/gotbanners/gotbanners.txt'));
	$s_con = split("~",$fcontents);

	$count = count($s_con);

	$nums = got_rand(0,$count-1,$count);

	echo '<div class="post clearfix">';

	for($j=0; $j<$count; $j++)
	echo $s_con[$nums[$j]];

	echo '</div>';
}

function widget_gotbanners($args)
{
	extract($args);

	$options = get_option('widget_gotbanners');
	$title = $options['title'];

	echo $before_widget . $before_title . $title . $after_title;
	got_banners();
	echo $after_widget;
}

function widget_gotbanners_control() 
{

		// Get our options and see if we're handling a form submission.
		$options = get_option('widget_gotbanners');
		if ( !is_array($options) )
			$options = array('title'=>'');
		if ( $_POST['gotbanners-submit'] ) {

			// Remember to sanitize and format use input appropriately.
			$options['title'] = strip_tags(stripslashes($_POST['gotbanners-title']));
			update_option('widget_gotbanners', $options);
		}

		// Be sure you format your options to be valid HTML attributes.
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		
		// Here is our little form segment. Notice that we don't need a
		// complete form. This will be embedded into the existing form.
		echo '<p style="text-align:right;"><label for="gotbanners-title">' . __('Title:') . ' <input style="width: 200px;" id="gotbanners-title" name="gotbanners-title" type="text" value="'.$title.'" /></label></p>';
		echo '<input type="hidden" id="gotbanners-submit" name="gotbanners-submit" value="1" />';
}


register_sidebar_widget(array('Got Banners', 'widgets'), 'widget_gotbanners');
register_widget_control(array('Got Banners', 'widgets'), 'widget_gotbanners_control', 300, 100);

}

add_action('widgets_init', 'widget_gotbanners_init');

?>